# Line Menu Styles

An open collection of menu styles that use the line as a creative design element.

[Article on Codrops](http://tympanus.net/codrops/?p=25842)

[Demo](http://tympanus.net/Development/LineMenuStyles/)

![Line Menu Styles](http://tympanus.net/codrops/wp-content/uploads/2016/01/menustyle.gif)

## Contribute

_Please don't add any other changes to a pull request for new styles. If you want to contribute some other updates to the repo, make sure to add those in a different pull request._

You can submit your style in the following way:
1. Fork this repo
2. Copy the following snippet and insert it before the dummy section:
```html
	<section class="section section--menu" id="Yourstyle">
		<h2 class="section__title">Your style</h2>
		<span class="link-copy"></span>
		<nav class="menu menu--yourstyle">
			<ul class="menu__list">
				<li class="menu__item menu__item--current"><a class="menu__link">Home</a></li>
				<li class="menu__item"><a class="menu__link">Portfolio</a></li>
				<li class="menu__item"><a class="menu__link">Blog</a></li>
				<li class="menu__item"><a class="menu__link">Shop</a></li>
				<li class="menu__item"><a class="menu__link">Contact</a></li>
			</ul>
		</nav>
		<p class="info">Style created by <a href="">[your name]</a></p>
	</section>
```
3. Choose a Shakespeare character name as title and replace it with "yourstyle" (id, title, menu--[name])
4. Add your styles to the ___component.css___ right before the media query. Please don't forget the -webkit- prefixed properties where necessary.
5. Add your name and social/website link to the info paragraph.
6. Please credit if you base your style on an existing design. You can do so by adding a paragraph with the class `info` after your menu.

_Please test your styles in the latest stable releases of all common browsers (Chrome, Safari, Firefox, IE), preferrable on Win and Mac and mobile if possible._

__We'll carefully select the best styles.__

## License

Integrate or build upon it for free in your personal or commercial projects. Don't republish, redistribute or sell "as-is".

Read more here: [License](http://tympanus.net/codrops/licensing/)

## Credits

- Link icon from [Iconic](https://github.com/iconic/open-iconic)

## Misc

Follow Codrops: [Twitter](http://www.twitter.com/codrops), [Facebook](http://www.facebook.com/pages/Codrops/159107397912), [Google+](https://plus.google.com/101095823814290637419), [GitHub](https://github.com/codrops), [Pinterest](http://www.pinterest.com/codrops/)

[© Codrops 2016](http://www.codrops.com)





